routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

Auth::routes();

Route::middleware('auth')->group(function () {
    /* Home */
    Route::get('/', 'HomeController@index')->name('home');

    /* Procedure */
    Route::prefix('procedure')->group(function () {
        Route::name('procedure.')->group(function () {
            Route::get('', 'ProcedureController@index')->name('index');
            Route::get('create', 'ProcedureController@create')->name('create');
            Route::post('', 'ProcedureController@store')->name('store');
            Route::get('{id}/edit', 'ProcedureController@edit')->name('edit');
            Route::put('{id}', 'ProcedureController@update')->name('update');
            Route::delete('{id}', 'ProcedureController@destroy')->name('destroy');
            Route::get('{id}/documents', 'ProcedureController@showDocuments')->name('showDocuments');
            Route::get('{id}/contacts', 'ProcedureController@showContacts')->name('showContacts');
            Route::get('search/{query}', 'ProcedureController@search')->name('search');
        });
    });

    /* Category */
    Route::prefix('category')->group(function () {
        Route::name('category.')->group(function () {
            Route::post('', 'CategoryController@store')->name('store');
            Route::put('{id}', 'CategoryController@update')->name('update');
            Route::delete('{id}', 'CategoryController@destroy')->name('destroy');
        });
    });

    /* Document */
    Route::prefix('document')->group(function () {
        Route::name('document.')->group(function () {
            Route::post('', 'DocumentController@store')->name('store');
            Route::post('{id}/file', 'DocumentController@storeFile')->name('store.file');
            Route::get('{id}/file', 'DocumentController@downloadFile')->name('download.file');
            Route::put('{id}', 'ProcedureController@update')->name('update');
            Route::delete('{id}', 'ProcedureController@destroy')->name('destroy');
        });
    });

    /* Contact */
    Route::prefix('contact')->group(function () {
        Route::name('contact.')->group(function () {
            Route::post('', 'ContactController@store')->name('store');
            Route::put('{id}', 'ContactController@update')->name('update');
            Route::delete('{id}', 'ContactController@destroy')->name('destroy');
            Route::get('{id}/phones', 'ContactController@showPhones')->name('showPhones');
        });
    });

    /*Phone*/
    Route::prefix('phone')->group(function () {
        Route::name('phone.')->group(function () {
            Route::post('', 'PhoneController@store')->name('store');
            Route::put('{id}', 'PhoneController@update')->name('update');
            Route::delete('{id}', 'PhoneController@destroy')->name('destroy');
        });
    });
});

app/Procedure.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Procedure extends Model
{
    protected $fillable = ['title', 'content', 'abstract', 'id_user', 'id_category'];

    public function category()
    {
        return $this->belongsTo('App\Category');
    }

    public function documents()
    {
        return $this->belongsToMany('App\Document');
    }

    public function user()
    {
        return $this->belongsTo('App\User');
    }

    public function contacts()
    {
        return $this->belongsToMany('App\Contact');
    }
}

app/Http/Controllers/ProcedureController.php
<?php

namespace App\Http\Controllers;

use App\Category;
use App\Contact;
use App\Document;
use App\Helpers\Utils;
use App\Http\Requests\StoreProcedure;
use App\Procedure;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\View\View;
use PhpParser\Comment\Doc;

class ProcedureController extends Controller
{
    use Utils;

    /**
     * Display a listing of the resource.
     *
     * @return View
     */
    public function index(): View
    {
        return view('procedure/index');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return View
     */
    public function create(): View
    {
        return view('procedure/create' , ['categories' => Category::all(), 'documents' => Document::all(), 'contacts' => Contact::all()]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param StoreProcedure $request
     * @return RedirectResponse
     */
    public function store(StoreProcedure $request): RedirectResponse
    {
        $procedure = new Procedure(['title'=> $request->title, 'content' => $request->contenu, 'abstract' => $request->abstract]);
        $procedure->user_id = Auth::id();
        $procedure->category_id = $request->category;
        $procedure->save();
        $procedure->documents()->sync($request->documents);
        $procedure->contacts()->sync($request->contacts);
        return redirect()->route('procedure.edit', $procedure->id)->with('success', 'Procédure sauvegardée');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return string
     */
    public function showDocuments($id): string
    {
        try {
            $procedure = Procedure::findOrFail($id);
            return Document::getSeparatedDocs($procedure->documents)->toJson();
        } catch (\Exception $e) {
            return json_encode(['success' => false]);
        }
    }

    public function showContacts($id): string
    {
        try {
            $procedure = Procedure::findOrFail($id)->load('contacts.phones');
            return $procedure->contacts->toJson();
        } catch (\Exception $e) {
            return json_encode(['success' => false]);
        }
    }
    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return View|string
     */
    public function edit($id)
    {
        try {
            $procedure = Procedure::find($id);
            return view('procedure/edit', [
                'procedure' => $procedure,
                'categories' => Category::all(),
                'documents' => collect([
                    'checkedDocs' => $procedure->documents,
                    'noCheckedDocs' => Document::all()->diff($procedure->documents)
                    ]),
                'contacts' => collect([
                    'checkedContacts' => $procedure->contacts,
                    'noCheckedContacts' => Contact::all()->load('phones')->diff($procedure->contacts)
                ]),
            ]);
        } catch (\Exception $e) {
            return json_encode(['success' => false]);
        }
    }

    /**
     * Update the specified resource in storage.
     *
     * @param StoreProcedure $request
     * @param int $id
     * @return RedirectResponse
     */
    public function update(StoreProcedure $request, $id)
    {
        $procedure = Procedure::findOrFail($id);
        $procedure->user_id = Auth::id();
        $procedure->category_id = $request->category;
        $procedure->title = $request->title;
        $procedure->save();
        $procedure->documents()->sync($request->documents);
        return redirect()->route('procedure.edit', $procedure->id)->with('success', 'Procédure modifiée');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return RedirectResponse
     */
    public function destroy($id)
    {
        Procedure::destroy($id);
        return back()->with('success', 'Procédure supprimée');
    }

    public function search(Request $request, $query)
    {
        if($query == 'empty') {
            return Procedure::all()->load('category', 'documents', 'contacts')->toJson();
        }
        $procedures = Procedure::all()->filter(function ($procedure) use ($query) {
            $procedure->load('category', 'documents', 'contacts');
            return self::searchIn($procedure->toArray(), $query);
        });
        return $procedures->load('category', 'documents', 'contacts')->toJson();
    }
}

resources/views/procedure/base_form_procedure.blade.php
@extends('layouts.app')

@section('content')
    <div class="container-fluid">
        <div class="row justify-content-center">
            <div class="col-md-5">
              @yield('form_procedure')
            </div>
            <div class="col-md-2">
                <div class="row mb-5">
                    <div class="col">
                        <div class="accordion" id="addAccordion">
                            <div class="card">
                                <div class="card-header" id="headingOneTwo">
                                    <h2 class="mb-0">
                                        <button style="font-size: 0.7em"  class="btn btn-link" type="button" data-toggle="collapse" data-target="#collapseOneTwo" aria-expanded="true" aria-controls="collapseOneTwo">
                                            <i class="far fa-folder mr-3"></i>Ajouter un document
                                        </button>
                                    </h2>
                                </div>
                                <div id="collapseOneTwo" class="collapse show" aria-labelledby="headingOneTwo" data-parent="#addAccordion">
                                    <div class="card-body">
                                        <div id="documentNameGroup" class="row">
                                            <form class="form-inline" method="POST" action="/document" id="documentForm">
                                                @csrf
                                                <div class="form-group mx-sm-3 mb-2">
                                                    <label for="documentName" class="sr-only">Nom</label>
                                                    <input type="text" class="form-control" id="documentName" placeholder="Nom du document">
                                                </div>
                                                <div class="form-group">
                                                    <button type="submit" id="saveDocumentName" class="btn btn-primary mb-2">Suivant</button>
                                                    <div class="spinner-border" id="spinnerDocument" style="display: none" role="status">
                                                        <span class="sr-only">Loading...</span>
                                                    </div>
                                                </div>
                                            </form>
                                        </div>
                                        <div id="documentFileGroup" style="display: none" class="row mb-4">
                                            <form action="" method="POST" class="col-12">
                                                <div class="row mb-4">
                                                    <div class="col">
                                                        <div class="dropzone dragDrop mx-auto" id="documentDropzone">
                                                        </div>
                                                    </div>
                                                </div>
                                                <div class="row text-center">
                                                    <div class="col-6">
                                                        <button type="submit" id="documentFile" class="btn btn-primary">
                                                            Envoyer
                                                        </button>
                                                    </div>
                                                    <div class="col-6">
                                                        <button type="submit" id="noDocumentFile" class="btn btn-success">
                                                            Passer
                                                        </button>
                                                    </div>
                                                </div>
                                            </form>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="card">
                                <div class="card-header" id="headingTwoTwo">
                                    <h2 class="mb-0">
                                        <button style="font-size: 0.7em"  class="btn btn-link collapsed" type="button" data-toggle="collapse" data-target="#collapseTwoTwo" aria-expanded="false" aria-controls="collapseTwoTwo">
                                            <i class="far fa-address-book mr-3"></i>Ajouter un contact
                                        </button>
                                    </h2>
                                </div>
                                <div id="collapseTwoTwo" class="collapse" aria-labelledby="headingTwoTwo" data-parent="#addAccordion">
                                    <div class="card-body">
                                        <form id="newContactForm" action="" method="POST">
                                            @csrf
                                            <div class="form-group row">
                                                <label for="firstname" class="col-md-4 col-form-label text-md-right">Prénom</label>
                                                <div class="col-md-8">
                                                    <input type="text" id="firstname" class="form-control" name="firstname" >
                                                </div>
                                            </div>
                                            <div class="form-group row">
                                                <label for="lastname" class="col-md-4 col-form-label text-md-right">Nom</label>
                                                <div class="col-md-8">
                                                    <input type="text" id="lastname" class="form-control" name="lastname" >
                                                </div>
                                            </div>
                                            <div class="form-group row">
                                                <label for="email" class="col-md-4 col-form-label text-md-right">Email</label>
                                                <div class="col-md-8">
                                                    <input type="email" id="email" class="form-control" name="email" >
                                                </div>
                                            </div>
                                            <div class="form-group row">
                                                <label for="company" class="col-md-4 col-form-label text-md-right">Société</label>
                                                <div class="col-md-8">
                                                    <input type="text" id="company" class="form-control" name="company" >
                                                </div>
                                            </div>
                                            <div class="form-group row">
                                                <label for="address" class="col-md-4 col-form-label text-md-right">Adresse</label>
                                                <div class="col-md-8">
                                                    <textarea id="address" class="form-control" name="address" ></textarea>
                                                </div>
                                            </div>
                                            <div id="numberAdded">
                                            </div>
                                            <div class="form-group row" id="buttonAddPhone">
                                                <div class="col">
                                                    Ajouter un numéro
                                                </div>
                                                <div class="col">
                                                    <button id="addNumber" type="button" class="close float-left text-primary" data-toggle="tooltip"  data-placement="bottom" title="Liste des documents">
                                                        <span aria-hidden="true" class="fas fa-plus"></span>
                                                    </button>
                                                </div>
                                            </div>
                                            <div class="form-row h-100" id="phoneForm" style="display: none">
                                                <div class="form-group col-md-5">
                                                    <label for="label">Libellé</label>
                                                    <input type="text" class="form-control" name="label" id="label" placeholder="Portable">
                                                </div>
                                                <div class="form-group col-md-6">
                                                    <label for="number">Numéro</label>
                                                    <input type="text" name="number" class="form-control" id="number" placeholder="06........">
                                                </div>
                                                <div class="form-group col-md-1 my-auto">
                                                    <a href="" id="saveNewPhone">
                                                        <i class="fas fa-plus fa-2x"></i>
                                                    </a>
                                                </div>
                                            </div>
                                            <div class="form-group row">
                                                <label for="comments" class="col-md-4 col-form-label text-md-right">Commentaires</label>
                                                <div class="col-md-8">
                                                    <textarea id="comments" class="form-control" name="comments" ></textarea>
                                                </div>
                                            </div>
                                            <div class="form-group row text-center">
                                                <div class="col">
                                                    <button type="submit" id="contactSubmit" class="btn btn-primary">
                                                        Envoyer
                                                    </button>
                                                </div>
                                            </div>
                                        </form>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/procedure/contact_card.blade.php
<div id="contactCard" class="modal fade shadow" role="dialog">
    <div class="modal-dialog modal-lg float-left modal-dialog-centered ml-4 modal-dialog-scrollable" role="document">
        <div class="modal-content">
            <div class="row p-3">
                <div class="col"><h5 class="modal-title w-100 text-center font-weight-bold text-primary" id="fullName"></h5></div>
                <div class="col-1">
                    <button type="button" class="close float-right text-primary" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true" class="fa fa-times"></span>
                    </button>
                </div>
            </div>
            <div class="row mt-0">
                <div class="col">
                    <div id="contact" class="modal-body col-12 pt-0">
                        <div class="col-md">
                            <div class="contact-box center-version">
                                <strong id="company"></strong><br>
                                <address class="m-t-md" id="address">
                                </address>
                                <div id="phones" class="mb-3"></div>
                                <a id="email" href="" class="mb-1"><span></span></a>
                                <div id="comments" class="font-italic my-4"></div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

resources/views/procedure/form_procedure.blade.php
@extends('procedure.base_form_procedure')

@section('form_procedure')
    <form method="POST" action="{{ 'procedure.edit' === Route::current()->getName() ? route('procedure.update', $procedure->id) : route('procedure.store') }}">
        @csrf
        @if ('procedure.edit' === Route::current()->getName())
            @method('PUT')
        @endif
        <div class="accordion" id="accordionExample">
            <div class="card">
                <div class="card-header" id="headingOne">
                    <h2 class="mb-0">
                        <button style="font-size: 0.7em" class="btn btn-link" type="button" data-toggle="collapse" data-target="#collapseOne" aria-expanded="true" aria-controls="collapseOne">
                            <i class="far fa-file-alt mr-3"></i>Procédure
                        </button>
                    </h2>
                </div>
                <div id="collapseOne" class="collapse show" aria-labelledby="headingOne" data-parent="#accordionExample">
                    <div class="card-body">
                        <div class="row mb-4">
                            <div class="col"><span class="text-muted">Rédiger ici la procédure</span></div>
                        </div>
                        <div class="form-group row">
                            <label for="title" class="col-md-4 col-form-label text-md-right">Titre</label>
                            <div class="col-md-6">
                                @yield('procedure.title')
                                @error('title')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                @enderror
                            </div>
                        </div>
                        <div class="form-group row">
                            <label for="category" class="col-md-4 col-form-label text-md-right">Category</label>
                            <div class="col-md-6">
                                <div>
                                    @yield('procedure.category')
                                    <div id="createCategory" style="display: none">
                                        <div class="row mt-4">
                                            <div class="col-md-10">
                                                <input placeholder="Nom de la categorie" id="catName" type="text" class="form-control" name="catName" autofocus>
                                                <span class="invalid-feedback" id="catNameError" role="alert">
                                            <strong></strong>
                                        </span>
                                            </div>
                                            <div class="col-md-2">
                                                <a href="" id="saveNewCategory">
                                                    <i class="far fa-save fa-2x"></i>
                                                </a>
                                                <div class="spinner-border" id="spinnerCategory" style="display: none" role="status">
                                                    <span class="sr-only">Loading...</span>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                @error('category')
                                <span class="invalid-feedback" role="alert">
                                <strong>{{ $message }}</strong>
                            </span>
                                @enderror
                            </div>
                        </div>
                        <div class="form-group row">
                            <label class="col-md-4 col-form-label text-md-right" for="abstract">Resumé</label>
                            <div class="col-md-6">
                                @yield('procedure.abstract')
                            </div>
                            @error('abstract')
                                <span class="invalid-feedback" role="alert">
                                    <strong>{{ $message }}</strong>
                                </span>
                            @enderror
                        </div>
                        <div class="form-group row">
                            <div class="col-md-12">
                                @yield('procedure.content')
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="card">
                <div class="card-header" id="headingTwo">
                    <h2 class="mb-0">
                        <button style="font-size: 0.7em" class="btn btn-link collapsed" type="button" data-toggle="collapse" data-target="#collapseTwo" aria-expanded="false" aria-controls="collapseTwo">
                            <i class="far fa-folder mr-3"></i> Documents
                        </button>
                    </h2>
                </div>
                <div id="collapseTwo" class="collapse" aria-labelledby="headingTwo" data-parent="#accordionExample">
                    <div class="card-body">
                        <div class="row mb-4">
                            <div class="col"><span class="text-muted">Choisir ici les documents de la procédure</span></div>
                        </div>
                        <div class="form-group row" id="documentsCheck">
                            @yield('procedure.documents')
                        </div>
                        <div class="row">
                            <div class="col"><span class="text-primary mr-3">Téléchargeable</span><span class="text-dark">Non Téléchargeable</span></div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="card">
                <div class="card-header" id="headingThree">
                    <h2 class="mb-0">
                        <button style="font-size: 0.7em" class="btn btn-link collapsed" type="button" data-toggle="collapse" data-target="#collapseThree" aria-expanded="false" aria-controls="collapseThree">
                            <i class="far fa-address-book mr-3"></i>Contact
                        </button>
                    </h2>
                </div>
                <div id="collapseThree" class="collapse" aria-labelledby="headingThree" data-parent="#accordionExample">
                    <div class="card-body">
                        <div class="row mb-4">
                            <div class="col"><span class="text-muted">Choisir ici les contacts de la procédure</span></div>
                        </div>
                        <div class="row mb-4" id="contacts">
                            @yield('procedure.contact')
                        </div>
                    </div>
                </div>
            </div>
            <div class="card">
                <div class="card-body">
                    <div class="form-group row mb-0">
                        <div class="col-md-12 text-center">
                            <button type="submit" class="btn btn-primary">
                                Enregistrer
                            </button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </form>
@endsection

@section('script')
    <script src="https://cdn.tiny.cloud/1/yme02n5ckioeoumbn9mr6hcl1r3u5rn8ubfeqbsyw79quoss/tinymce/5/tinymce.min.js" referrerpolicy="origin"></script>
    <script src="{{asset('js/procedure.create.edit.js')}}"></script>
@endsection